﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using System.Net.Sockets;
using System.IO;

namespace tcpclient_forsolid
{
    public partial class Form1 : Form
    {
        static string showstrings = "no data";
        static string shownum = "Data num: 0";
        public Form1()
        {
            InitializeComponent();
        }

        private void button1_Click(object sender, EventArgs e)
        {
            button1.Enabled = false;

            Connect("raspberrypi", "AAA");

            label1.Text = showstrings;
            label2.Text = shownum;

            button1.Enabled = true;
        }
        static void Connect(String server, String message)
        {
            try
            {
                // Create a TcpClient.
                // Note, for this client to work you need to have a TcpServer
                // connected to the same address as specified by the server, port
                // combination.
                Int32 port = 7777;

                // Prefer a using declaration to ensure the instance is Disposed later.
                TcpClient client = new TcpClient(server, port);

                // Translate the passed message into ASCII and store it as a Byte array.
                Byte[] data = System.Text.Encoding.ASCII.GetBytes(message);

                // Get a client stream for reading and writing.
                NetworkStream stream = client.GetStream();

                // Send the message to the connected TcpServer.
                stream.Write(data, 0, data.Length);

                Console.WriteLine("Sent: {0}", message);

                // Receive the server response.

                // Buffer to store the response bytes.
                data = new Byte[4096];

                // String to store the response ASCII representation.
                String responseData = String.Empty;

                // Read the first batch of the TcpServer response bytes.
                Int32 bytes = stream.Read(data, 0, data.Length);
//                responseData = System.Text.Encoding.ASCII.GetString(data, 0, bytes);
//                Console.WriteLine("Received: {0}", responseData);

//                float x_axis = BitConverter.ToSingle(data, 0);
//                float y_axis = BitConverter.ToSingle(data, 4);
//                float z_axis = BitConverter.ToSingle(data, 8);
                float x_axis = BitConverter.ToSingle(data, bytes - 12);
                float y_axis = BitConverter.ToSingle(data, bytes - 8);
                float z_axis = BitConverter.ToSingle(data, bytes - 4);

                showstrings = "[Latest] x:" + x_axis.ToString() + "  y:" + y_axis.ToString() + "  z:" + z_axis.ToString();
                shownum = "Data num: " + (bytes/12).ToString();

                DateTime dt = DateTime.Now;
                String name = dt.ToString("{yyyyMMdd_HHmmss}") + ".csv";

                using (StreamWriter sw = new StreamWriter(@name, false, Encoding.UTF8))
                {

                    sw.WriteLine(shownum);
                    sw.WriteLine("x_axis, y_axis, z_axis");
                    for (int i=0; i< bytes; i += 12)
                    {
                        String str_line = BitConverter.ToSingle(data, i).ToString() + "," + BitConverter.ToSingle(data, (i + 4)).ToString() + "," + BitConverter.ToSingle(data, (i + 8)).ToString();
                        sw.WriteLine(str_line);
                    }
                }
                // Explicit close is not necessary since TcpClient.Dispose() will be
                // called automatically.
                // stream.Close();
                // client.Close();
            }
            catch (ArgumentNullException e)
            {
                Console.WriteLine("ArgumentNullException: {0}", e);
            }
            catch (SocketException e)
            {
                Console.WriteLine("SocketException: {0}", e);
            }

            Console.WriteLine("\n Press Enter to continue...");
            Console.Read();
        }
    }
}
